/**
 * ТУТ РАЗМЕЩЕНО ДВА ЗАДАНИЯ!
 * 
 * ЗАДАНИЕ №1
 *  [Symbol.iterator]
 * Условия:
 * 1. Раскомментруйте и посмотрите код "АЛЬТЕРНАТИВНАЯ РЕАЛИЗАЦИЯ ОБЪЕКТА RANGE" ниже, реализующий объект range (делает тоже самое)
 * 2. Разберитесь как он работает
 * 3. Допишите класс DispersionArray
 * 4. Класс должен работать следующим образом:
 *    4.1 При создании экземпляра класс в конструктор передается число centerPoint (средняя точка) и число dispersion (разброс)
 *    4.2 Экземпляр класса должен быть перебираемым объектом --
 *   -- если пройтись по нему циклом for...of то получим целые числа от (centerPoint - dispersion) до (centerPoint + dispersion)
 *    4.3 Для этого необходимо самостоятельно реализовать метод [Symbol.iterator]
 *    4.4 И метод next
 * 5. Выполнить действия с экземплярами класса DispersionArray указанные в "Вторая часть задания #1"
 * 
 * ПОЯСНЕНИЯ 
 *  Если, например в конструктор DispersionArray передать значения (2,3) где 2 - centerPoint, а 3 - dispersion
 *  то при обходе полученного объекта циклом for of мы получим последовательность -- -1,0,1,2,3,4,5
 *  Тоесть начинается диапазон от значения, равного centerPoint - dispersion
 *  Заканчивается он на значении centerPoint + dispersion
*/

// ЭТО НАДО ЗАКОММЕНТИРОВАТЬ
// -------------------------
let range = {
  from: 1,
  to: 5
};
// -------------------------

// for (let num of range) { // Ошибка - range is not iterable
//   alert(num);
// }

// ЭТО НАДО ЗАКОММЕНТИРОВАТЬ
// -------------------------
// 1. вызов for..of сначала вызывает эту функцию
range[Symbol.iterator] = function () {
  // ...она возвращает объект итератора:
  // 2. Далее, for..of работает только с этим итератором, запрашивая у него новые значения
  return {
    current: this.from,
    last: this.to,

    // 3. next() вызывается на каждой итерации цикла for..of
    next() {
      // 4. он должен вернуть значение в виде объекта {done:.., value :...}
      if (this.current <= this.last) {
        return { done: false, value: this.current++ };
      } else {
        return { done: true };
      }
    }
  };
};
// теперь работает!
for (let num of range) {
  console.log(num); // 1, затем 2, 3, 4, 5
}
// -------------------------

/**
 * АЛЬТЕРНАТИВНАЯ РЕАЛИЗАЦИЯ ОБЪЕКТА RANGE
 * ======================================
 * let range = {
 *  from: 1,
 *  to: 5,
 *  // вначале цкл for...of вернет вызовет [Symbol.iterator]
 *  [Symbol.iterator]() {
 *    this.current = this.from;
 *    // вернет сам объект range у которого есть метод next
 *    return this;
 *  },
 *  // полсе того как [Symbol.iterator] вернет range
 *  // for...of вызовет у него метод next
 *  next() {
 *    if (this.current <= this.to) {
 *      return { done: false, value: this.current++ };
 *    } else {
 *      return { done: true };
 *    }
 *  }
 *};
 * ==========================================
 */
/**
 * ДОПИШИТЕ КЛАСС
 * ===========================================
 */
class DispersionArray {
  constructor(centerPoint, dispersion) {
    /**
     * ВАШ КОД ТУТ
     * this.from = ...
     * this.to = ...
     */
  }
  [Symbol.iterator]() {
    /**
   * ВАШ КОД ТУТ
     * должен возвращать сам объект
   */
  }
  next() {
    /**
     * ВАШ КОД ТУТ
     * должен возвращать каждый следующий элемент диапазона
     */
  }
}

/**
 * ========================================================
 * Вторая часть задания #1
 * ========================================================
 * ВАШ КОД ТУТ
 * 1. Создайте два экземпляра (firDict и secDict) класса DispersionArray
 * 2. Первому экземпляру firDict в качетве прототпа укажите null
 * 3. Пройдитесь по второму эземпляру secDict циклом for...of и убедитесь что он корректно выводит все числа в заданном диапазоне
 * 4. Откройте браузер и выведите secDict --  у него есть итератор? С чем это связано? -- ответ оставьте в комментарии ниже в разделе "ПОЧЕМУ ТАК"
 */
/**
 * ПОЧЕМУ ТАК
 * =========================================================
 * ВАШ КОММЕНТАРИЙ ТУТ
 *
 */



/**
 * ЗАДАНИЕ №2
 * 1. Унаследовать ваш собственный класс, например 'MyStr' от базового String
 * 2. Добавить в MyStr метод фильтрации HTML
 * 3. Унаследовать еще один класс, например 'ChildStr' у вашего класса 'MyStr'
 * 4. У нового дочернего класс 'ChildStr' реализовать метод, который изменяет исходную строку
 * 5. Если на вход такого метода передать 'hello world' то получим 'HeLlO WoRd'
 *
 * ПОДСТКАЗКА КАК ФИЛЬТРОВАТЬ HTML: 
 * const string = 'Some text with <span class="highlighted">highlighted text</span>'
 * string.toString().replace(/<[^>]*>?/gm, '') - удаляет HTML код из строки
 *
 */
